# opentl::core::util::SD_GroundTruth Class Reference

Class for reading and writing XML based ground truth data and configuration settings for generating this data. More...

Inherits opentl::core::util::SerializedData.

List of all members.

## Public Member Functions
void | addColladaTarget (const std::string &filename)
| Add target generated from Collada file.
std::string & | getColladaFilename (std::size_t targetIdx)
| Get target related Collada filename.
void | getPoseData (math::Vector *dstPoseData, std::size_t frameIdx, std::size_t targetIdx=0)
| Get pose data related to a certain target and frame index.
std::size_t | getTargetCount () const
| Get number of targets for which ground truth data is stored.
void | getWorldT (math::Transform &dstT, std::size_t frameIdx, std::size_t targetIdx=0)
| Get transformation matrix T (object to world) related to a certain target and frame index.
| SD_GroundTruth ()
virtual | ~SD_GroundTruth ()
| Destructor.
## Public Attributes
SD_math_vector | backgroundColor
| Background color in video.
std::string | backgroundImageFilename
| Background image filename.
std::string | backgroundVideoFilename
| Background video filename.
double | camFocus
| Camera focus.
int | camIndex
| Camera index.
int | camResX
| Camera resolution x.
int | camResY
| Camera resolution y.
std::string | dataSeriesName
| Informative remark related to ground truth data/video content.
modelprojection::GLRenderer::DrawMode | drawMode
| GLRenderer draw mode.
SD_math_vector | foregroundColor
| Foreground color in video.
std::size_t | frameCount
| Frame count, required for interpolation.
double | framesPerSecond
| Frames per second in video.
std::string | resultingVideoFilename
| Name of resulting video file.
std::vector< std::vector < SD_math_vector > > | trajectoryDataWorldPose
| Vector holding interpolated trajectory data in pose coordinates. outer dim = target idx, inner dim = frame idx.
std::vector< std::vector < SD_math_transform > > | trajectoryDataWorldT
| Vector holding interpolated trajectory data in as T object to world. outer dim = target idx, inner dim = frame idx.
opentl::core::cvdata::CvData::DataReprType | usedPoseType
| Used pose type for waypoint definition / interpolation.
opentl::core::cvdata::Pose::T_UPDATEMODE | usedPoseUpdateMode
| Used pose update mode.
std::vector< std::vector < SD_math_vector > > | wayPointWorldData
| Vector holding waypoint data. outer dim = target idx, inner dim = frame idx.
SD_math_transform | worldToCamT
| T world to cam.
## Friends
class | boost::serialization::access

## Detailed Description

Class for reading and writing XML based ground truth data and configuration settings for generating this data.

Author:
  E. Roth <eroth@mytum.de>

## Constructor & Destructor Documentation

opentl::core::util::SD_GroundTruth::SD_GroundTruth | ( |  | ) | `[inline]`

virtual opentl::core::util::SD_GroundTruth::~SD_GroundTruth | ( |  | ) | `[inline, virtual]`

Destructor.

## Member Function Documentation

void opentl::core::util::SD_GroundTruth::addColladaTarget | ( | const std::string & | filename | ) | `[inline]`

Add target generated from Collada file.

Parameters:

  | filename | Path to file

std::string& opentl::core::util::SD_GroundTruth::getColladaFilename | ( | std::size_t | targetIdx | ) | `[inline]`

Get target related Collada filename.

Parameters:

  | targetIdx | target index.

void opentl::core::util::SD_GroundTruth::getPoseData | ( | math::Vector * | dstPoseData,
|  | std::size_t | frameIdx,
|  | std::size_t | targetIdx = `0` |
| ) |  |  | `[inline]`

Get pose data related to a certain target and frame index.

Parameters:

  | dstPoseData | pose data.
  | frameIdx | frame index.
  | targetIdx | target index.

std::size_t opentl::core::util::SD_GroundTruth::getTargetCount | ( |  | ) | const`[inline]`

Get number of targets for which ground truth data is stored.

void opentl::core::util::SD_GroundTruth::getWorldT | ( | math::Transform & | dstT,
|  | std::size_t | frameIdx,
|  | std::size_t | targetIdx = `0` |
| ) |  |  | `[inline]`

Get transformation matrix T (object to world) related to a certain target and frame index.

Parameters:

  | dstT | Transformatio matrix.
  | frameIdx | frame index.
  | targetIdx | target index.

## Friends And Related Function Documentation

friend class boost::serialization::access`[friend]`

Reimplemented from opentl::core::util::SerializedData.

## Member Data Documentation

SD_math_vector opentl::core::util::SD_GroundTruth::backgroundColor

Background color in video.

std::string opentl::core::util::SD_GroundTruth::backgroundImageFilename

Background image filename.

std::string opentl::core::util::SD_GroundTruth::backgroundVideoFilename

Background video filename.

double opentl::core::util::SD_GroundTruth::camFocus

Camera focus.

int opentl::core::util::SD_GroundTruth::camIndex

Camera index.

int opentl::core::util::SD_GroundTruth::camResX

Camera resolution x.

int opentl::core::util::SD_GroundTruth::camResY

Camera resolution y.

std::string opentl::core::util::SD_GroundTruth::dataSeriesName

Informative remark related to ground truth data/video content.

modelprojection::GLRenderer::DrawMode opentl::core::util::SD_GroundTruth::drawMode

GLRenderer draw mode.

SD_math_vector opentl::core::util::SD_GroundTruth::foregroundColor

Foreground color in video.

std::size_t opentl::core::util::SD_GroundTruth::frameCount

Frame count, required for interpolation.

double opentl::core::util::SD_GroundTruth::framesPerSecond

Frames per second in video.

std::string opentl::core::util::SD_GroundTruth::resultingVideoFilename

Name of resulting video file.

std::vector<std::vector<SD_math_vector> > opentl::core::util::SD_GroundTruth::trajectoryDataWorldPose

Vector holding interpolated trajectory data in pose coordinates. outer dim = target idx, inner dim = frame idx.

std::vector<std::vector<SD_math_transform> > opentl::core::util::SD_GroundTruth::trajectoryDataWorldT

Vector holding interpolated trajectory data in as T object to world. outer dim = target idx, inner dim = frame idx.

opentl::core::cvdata::CvData::DataReprType opentl::core::util::SD_GroundTruth::usedPoseType

Used pose type for waypoint definition / interpolation.

opentl::core::cvdata::Pose::T_UPDATEMODE opentl::core::util::SD_GroundTruth::usedPoseUpdateMode

Used pose update mode.

std::vector<std::vector<SD_math_vector> > opentl::core::util::SD_GroundTruth::wayPointWorldData

Vector holding waypoint data. outer dim = target idx, inner dim = frame idx.

SD_math_transform opentl::core::util::SD_GroundTruth::worldToCamT

T world to cam.